var Dfe52000_RelacionamentoProdutoXProduto_Controller = function(ScreenService, MessageService, General, templateManager, ZhFilterPreferences, ZhReports) {

    var cdforneced;
    var nrinsjurforn;
    var nmrazsocforn;
    var nmrazsocfornfil;
    var nmunidade;
    var cdunidade;
    var FRANQUEADORA;

    this.filialDefault = function(args) {
        General.callRestEngine("est#/crud/filial", "FilterData", [{ name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA" }]).then((response) => {
            args.getField("NMFILIAL").widget.currentRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            args.getField("NMFILIAL").widget.currentRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;

        }, (error) => {
            let a = 1;
        });

    };

    this.novoRelacionamento = function(widget) {
        General.callRestEngine("df#/filial_franqueadora", "FilterData", []).then((success) => {
            let franquia = success.dataset.filial_franqueadora.EXISTE_FRANQUEADORA;
            let filial_franqueadora = success.dataset.filial_franqueadora.FRANQUEADORA;
            if (franquia && !filial_franqueadora) {
                MessageService.showMessageByCode('PERMISSAO_RELACIONAMENTO_GERAL');
            }
            else {
                widget.newRow();
                if (widget.appliedFilter) {
                    widget.currentRow.CDFORNECED = widget.appliedFilter.FILTER_ROW.CDFORNECED;
                    widget.currentRow.NMRAZSOCFORN = widget.appliedFilter.FILTER_ROW.NMRAZSOCFORN;
                }

            }
        });
    };

    this.novoRelacionamentoFilial = function(widget) {
        widget.newRow();
        if (widget.appliedFilter) {
            widget.currentRow.CDFORNECED = widget.appliedFilter.FILTER_ROW.CDFORNECED;
            widget.currentRow.NMRAZSOCFORN = widget.appliedFilter.FILTER_ROW.NMRAZSOCFORN;
            widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
            widget.currentRow.NRINSJURFORN = widget.appliedFilter.FILTER_ROW.NRINSJURFORN;
        }
    };
    
   this.verificaFranqueadora = function(widget) {
        General.callRestEngine("df#/filial_franqueadora", "FilterData", []).then((success) => {
            let franquia = success.dataset.filial_franqueadora.EXISTE_FRANQUEADORA;
            let filial_franqueadora = success.dataset.filial_franqueadora.FRANQUEADORA;
            if (franquia && !filial_franqueadora) {
                FRANQUEADORA = 'N';
                widget.styles[0].condition = 'true';
            }
            else {
                FRANQUEADORA = 'S';
                widget.styles[0].condition = 'false';
            }
            widget.reload();
        }); 
    };

    this.validaFranqueadora = function(widget) {
        if (FRANQUEADORA == 'N') {
            widget.getAction('edit').readOnly = true;
            widget.getAction('excluir').readOnly = true;
            widget.getAction('replicar').readOnly = true;
        }
        else {
            widget.getAction('edit').readOnly = false;
            widget.getAction('excluir').readOnly = false;
            widget.getAction('replicar').readOnly = false;

        }
        this.setOldCdprodutoxml(widget);
        this.setOldCdproduto(widget);
    };

    this.validacoesWidgetOnEnterOnce = function(filtroArgs) {

        var cabecalhoWidget = filtroArgs.owner;

        const defaultFilter = {
            "NMRAZSOCFORN": "",
            "CDFILIAL": "",
            "NRORG": ""
        };

        General.callRestEngine("est#/crud/filial", "FilterData", [{ name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA" }]).then((response) => {
            defaultFilter.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            defaultFilter.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.setOriginalFilter(cabecalhoWidget.id, defaultFilter);
            this.openFilter(cabecalhoWidget, defaultFilter);
        }, (error) => {
            this.openFilter(cabecalhoWidget, true);

        });

    };


    this.setGlobalVariables = function(currentRow) {
        if (!currentRow) return;
        
        cdforneced = currentRow.CDFORNECED;
        nrinsjurforn = currentRow.NRINSJURFORN;
        if (templateManager.container.getWidget('dfe52000_unidade_grid').isLastActiveWidget()) {
            nmrazsocfornfil = currentRow.NMRAZSOCFORN;
            nmunidade = currentRow.NMFILIAL;
            cdunidade = currentRow.CDFILIAL;
        }
        else {
            nmrazsocforn = currentRow.NMRAZSOCFORN;
        }
    };

    this.setFornecedIfIsNew = function(widget) {
        widget.currentRow.CDFORNECED = cdforneced;
        widget.currentRow.NRINSJURFORN = nrinsjurforn;
        widget.currentRow.NMRAZSOCFORN = nmrazsocforn;
    };

    this.setOldCdprodutoxml = function(widget) {
        if (!widget.currentRow.__is_new) {
            widget.currentRow.OLDCDPRODUTOXML = widget.currentRow.CDPRODUTOXML;
        }
    };
    
    this.setOldCdproduto = function(widget) {
        if (!widget.currentRow.__is_new) {
            widget.currentRow.OLDCDPRODUTO = widget.currentRow.CDPRODUTO;
        }
    };

    this.atualizaNomeFornecedor = function(widget) {
        var fieldFornecedor = widget.getField('Fornecedor');
        var fieldUnidade = widget.getField('Unidade');
        
        var unidadeWidget = templateManager.container.getWidget('dfe52000_unidade_grid');
        var geralWidget = templateManager.container.getWidget('dfe52000_grid');
        
        if (unidadeWidget.isLastActiveWidget()) {
            if (unidadeWidget.appliedFilter) {
                fieldFornecedor.setValue(nrinsjurforn + ' | ' + nmrazsocfornfil);
                fieldUnidade.setValue(cdunidade + ' | ' + nmunidade);
            }
            else {
                fieldFornecedor.setValue('');
                fieldUnidade.setValue('');
            }
            fieldUnidade.isVisible = true;
            fieldFornecedor.class = "8";
        }
        else {
            if (geralWidget.appliedFilter) {
                fieldFornecedor.setValue(nrinsjurforn + ' | ' + nmrazsocforn);
            }
            else {
                fieldFornecedor.setValue('');
            }
            fieldUnidade.isVisible = false;
            fieldFornecedor.class = "12";
        }
    };

    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container = templateManager.container;
        if (container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if (f) {
                    filterWidget = container.getWidget(widgetName).appliedFilter;
                }

            }

            if (filterWidget) {
                var valueField;
                if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];

                return valueField || null;
            }
            else return null;
        }
        else return null;
    };

    this.generateReport = function(sourceWidget, format) {
        var labelWidget = sourceWidget.label;

        sourceWidget.label = "Relacionamento Produto X Produto - " + labelWidget;
        let customData = {};
        ZhReports.generateReport(customData, sourceWidget, this._previewCallback, function() {}, format).
        then (function () {
            sourceWidget.label = labelWidget;
        });
    };

    this._previewCallback = function(data) {
        var popup_window = window.open(data.path, '_blank');
        if (!popup_window) {
            ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
        }
    };
    
    this.excluirRelacionamento = function(widget) {
        
        MessageService.confirmMessageByCode("REGISTRO_EXCLUIR").then( function () {
            widget.removeRow().then(function() {
                ScreenService.closeSwipe();
                widget.reload();
            });
        });
    };
    
    this.save = function(widget) {
        var cdprodutoxml = widget.currentRow.CDPRODUTOXML;
        
        if(validaCodigoProdutoXML(widget) && widget.currentRow.__is_new) {
            MessageService.showMessageByCode('EXISTE_CDPRODUTOXML', {"CDPRODUTOXML": cdprodutoxml});
        } else {
            General.saveCrud(widget).then(() => {
                MessageService.successNotificationByCode('REGISTRO_SALVO');
            });
        }
    };
    
    var validaCodigoProdutoXML = function(widget) {
        var data = widget.dataSource.data;
        var cdprodutoxml = widget.currentRow.CDPRODUTOXML;
        var valido;
        
        data.forEach(function(element) {
            if(element.CDPRODUTOXML === cdprodutoxml)
                valido = true;
        });
        return valido;
    };
    
    this.adicionarReplicacaoRelacionamentoProduto = function(wdgReplicacao, widgetPai) {

        General.callRestEngine("df#/filial_franqueadora", "FilterData", []).then((success) => {
            let franquia = success.dataset.filial_franqueadora.EXISTE_FRANQUEADORA;
            let filial_franqueadora = success.dataset.filial_franqueadora.FRANQUEADORA;
            if (franquia && !filial_franqueadora) {
                MessageService.showMessageByCode('PERMISSAO_RELACIONAMENTO_GERAL').then((confirm) => {
                    ScreenService.closeSwipe();
                    this.closePopupReplicacaoRelacionamento(wdgReplicacao);
                });
                
            } else {
                wdgReplicacao.newRow();
                this.getCamposOrigemReplicacao(wdgReplicacao, widgetPai);       
            }
        });

    };
    
    this.adicionarReplicacaoRelacionamentoProdutoFilial = function(wdgReplicacao, widgetPai) {
        wdgReplicacao.newRow();
        this.getCamposOrigemReplicacao(wdgReplicacao, widgetPai);                                                                         
    };


    this.openPopupReplicacaoRelacionamento = function(wdgReplicacao, widgetPai) {
        this.getCamposOrigemReplicacao(wdgReplicacao, widgetPai);
        if(widgetPai.name === 'dfe52000_grid') 
            this.adicionarReplicacaoRelacionamentoProduto(wdgReplicacao, widgetPai);
        else 
            this.adicionarReplicacaoRelacionamentoProdutoFilial(wdgReplicacao, widgetPai);
        
        ScreenService.openPopup(wdgReplicacao);
    
    };
    
    this.getCamposOrigemReplicacao = function(wdgReplicacao, widgetPai) {
        wdgReplicacao.currentRow.NMRAZSOCFORNORIG = widgetPai.currentRow.NMRAZSOCFORN;
        wdgReplicacao.currentRow.NMPRODUTO = widgetPai.currentRow.NMPRODUTO;
        wdgReplicacao.currentRow.VRFATCONVOL =  widgetPai.currentRow.VRFATCONVOL;
        wdgReplicacao.currentRow.CDARVPROD = widgetPai.currentRow.CDARVPROD;
        wdgReplicacao.currentRow.CDPRODUTOXML = widgetPai.currentRow.CDPRODUTOXML;
        wdgReplicacao.currentRow.CDPRODUTO = widgetPai.currentRow.CDPRODUTO;
        wdgReplicacao.currentRow.NMPRODUTOXML = widgetPai.currentRow.NMPRODUTOXML;
        
        if(wdgReplicacao.name === 'replicacaoRelacionamentoProdutoFilial') {
            wdgReplicacao.currentRow.CDFILIAL = widgetPai.currentRow.CDFILIAL;
        }
        
    };
    
    this.closePopupReplicacaoRelacionamento = function(wdgReplicacao) {
        ScreenService.closePopup(wdgReplicacao);
        wdgReplicacao.isVisible = false;
    };
    
    this.alteraReadOnlyFornecedor = function(widget) {
        if(widget.name === 'dfe52000_grid') {
            widget.getField('NMRAZSOCFORN').readOnly = true;
        } else if(widget.name === 'dfe52000_unidade_grid'){
            widget.getField('NMRAZSOCFORN').readOnly = true;
            widget.getField('NMFILIAL').readOnly = true;
        } else {
            widget.getField('NMRAZSOCFORN').readOnly = false;
        }
        widget.reload();
    };
    
    this.alteraReadOnlyFornecedorReplicacao = function(widget) {

       var tnrInsJurForn   = widget.currentRow.TNRINSJURFORN;
        var fieldFornecedor = widget.getField("NMRAZSOCFORNDEST");


        if(tnrInsJurForn !== undefined) {
            if( tnrInsJurForn == 'T') {
                fieldFornecedor.clearValue();
                fieldFornecedor.readOnly = true;
            
                if(fieldFornecedor.validations) {
                    if(fieldFornecedor.validations.required) delete fieldFornecedor.validations.required;
                }
                
            } else { 
                fieldFornecedor.readOnly = false;
                
                if(fieldFornecedor.validations) 
                    fieldFornecedor.validations.required = true;
                else 
                    fieldFornecedor.validations = {required : {message: "Obrigatório"}};
                
            }
        } else {
            widget.currentRow.TNRINSJURFORN = 'L';
            this.alteraReadOnlyFornecedorReplicacao(widget);
        }
        
        this.validaCampoFornecedorDestino(widget);
        fieldFornecedor.reload();
    };
    
    this.openFilter = function(widget, defaultFilter) {
        ZhFilterPreferences.openFilterWidget(widget, defaultFilter).then(response => {
            var filter = templateManager.container.getActiveWidget();
            var clearFilter = filter.actions.filter(action => action.name === 'clear')[0];
            var confirmFilter = filter.actions.filter(action => action.name === 'never')[0];
            
            clearFilter.shortcutKey = 'ctrl+backspace';
            clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
            
            confirmFilter.shortcutKey = 'ctrl + enter';
            filter.reload();
            
        });
    };
    
    this.getFieldFocused = function(widget) {
        return widget.fields.filter(field => field.focused === true)[0];   
    };
    
    this.habilitarFocused = function(field, status) {
        if(status == true) {
            field.focused = true;
        } else {
            delete field.focused;
        }
    };
    
    this.saveReplic = function(widget) {
        if(widget.currentRow.NMRAZSOCFORNDEST !== 'undefined' && widget.currentRow.NMRAZSOCFORNDEST !== "") {
            var cdFornecedores = widget.currentRow.CDFORNECED;
            var cdFornecedorigem = widget.lastActiveWidget.appliedFilter.FILTER_ROW.CDFORNECED;
            var row;
            
            if(widget.lastActiveWidget.label == "Geral"){
                row = { CDFORNECEDORES: cdFornecedores, CDFORNECEDORIGEM: cdFornecedorigem};
                
                General.callRestEngine("df#/realizaReplicacao", "Row", row).then((success) =>  {
                    MessageService.successNotificationByCode('REPLICACAO_REALIZADA');
                },
                (error) => {
                    MessageService.errorNotificationByCode("ERRO_REPLICACAO");
                });
                this.closePopupReplicacaoRelacionamento(widget);
            } else {
                var cdFilial = widget.lastActiveWidget.appliedFilter.FILTER_ROW.CDFILIAL;
                row = { CDFORNECEDORES: cdFornecedores, CDFORNECEDORIGEM: cdFornecedorigem, CDFILIAL: cdFilial};
                
                General.callRestEngine("df#/realizaReplicacaoFilial", "Row", row).then((success) =>  {
                    MessageService.successNotificationByCode('REPLICACAO_REALIZADA');
                },
                (error) => {
                    MessageService.errorNotificationByCode("ERRO_REPLICACAO");
                });
                this.closePopupReplicacaoRelacionamento(widget);
            }
        } else {
            MessageService.showMessageByCode('FORNECEDOR_DESTINO_OBRIGATORIO');
        }
    };
    
    this.bloqueiaAcao = function(action, status) {
        if(status) 
            action.aclReadOnly = true;
        else 
            action.aclReadOnly = false;

    };
    
    this.validaCampoFornecedorDestino = function(widget) {
        var fonecedDestino  = widget.currentRow.NMRAZSOCFORNDEST;
        var tnrInsJurForn   = widget.currentRow.TNRINSJURFORN;
        var action          =     widget.actions.filter(action => action.name === 'salvar')[0];
        
        if( fonecedDestino === "" && tnrInsJurForn == 'L')
            this.bloqueiaAcao(action, true);
        else 
            this.bloqueiaAcao(action, false);

    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe52000_RelacionamentoProdutoXProduto_Controller", Dfe52000_RelacionamentoProdutoXProduto_Controller);
});
